const md5 = require('blueimp-md5')
const {
  Auth,
  UserCenter,
  Wallet
} = require('./service/api')

function BCWalletSDK(params) {
  this.appid = params.appid || ''
  this.appsecret = params.appsecret || ''
  this.tokenUrl = params.tokenUrl
  this.networkAPPID = params.networkAPPID
  this.networkYARN = params.networkYARN
  this.isWX = params.isWX
}

BCWalletSDK.prototype.getToken = async function (url) {
  const _ = await Auth.bcAuth(url, this.appid, this.appsecret, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('token', _);
  return _.result.token
}


BCWalletSDK.prototype.getUserOpenId = async function (url, userMobile) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await Auth.userAuth(url, userMobile, token, this.appid, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('getUserOpenId', _);
  return _
}

BCWalletSDK.prototype.sendMsgCode = async function (url, mobile, type) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await UserCenter.sendMsgCode(url, mobile, type, token, this.appid, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('sendMsgCode', _);
  return _
}

BCWalletSDK.prototype.registerUser = async function (url, mobile, password, msgCode) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await UserCenter.registerUser(url, mobile, md5(password), msgCode, token, this.appid, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('registerUser', _);
  return _
}
BCWalletSDK.prototype.getUserInfo = async function (url, uid) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await UserCenter.getUserInfo(url, uid, token, this.appid, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('getUserInfo', _);
  return _
}

BCWalletSDK.prototype.getCoinInfo = async function (url) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await UserCenter.getCoinInfo(url, this.appid, token, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('getCoinInfo', _);
  return _
}

BCWalletSDK.prototype.fetchAddress = async function (url) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await Wallet.fetchAddress(url, token, this.appid, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('fetchAddress', _);
  return _
}

BCWalletSDK.prototype.transfer = async function (url, from, to, count, flag) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await Wallet.transfer(url, from, to, count, token, this.appid, flag, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('transfer', _);
  return _
}
BCWalletSDK.prototype.giveCoin = async function (url, to, count, flag) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await Wallet.giveCoin(url, to, count, token, this.appid, flag, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('giveCoin', _);
  return _
}
BCWalletSDK.prototype.demandCoin = async function (url, fromID, count, msgCode, flag) {
  const token = await this.getToken(this.tokenUrl)
  const _ = await Wallet.demandCoin(url, fromID, count, msgCode, token, this.appid, flag, this.networkAPPID, this.networkYARN, this.isWX)
  console.log('demandCoin', _);
  return _
}

module.exports = BCWalletSDK